-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassMaterialManager.chs

-- 

module HGamer3D.Bindings.Ogre.ClassMaterialManager where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.Ogre.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}
import HGamer3D.Bindings.Ogre.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}
import HGamer3D.Bindings.Ogre.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}
import HGamer3D.Bindings.Ogre.StructSharedPtr
{-# LINE 43 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}

-- | Default constructor. 
new :: IO (HG3DClass)
 -- ^ 
new =
  alloca $ \a1' -> 
  new'_ a1' >>= \res ->
  peek  a1'>>= \a1'' -> 
  return (a1'')
{-# LINE 48 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}

-- | Default destructor. 
delete :: HG3DClass  -- ^ classpointer - pointer of Class instance which is going to be deleted.
  ->  IO ()
 -- ^ 
delete a1 =
  withHG3DClass a1 $ \a1' -> 
  delete'_ a1' >>= \res ->
  return ()
{-# LINE 52 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}

-- | Initialises the material manager, which also triggers it to parse all available .program and .material scripts. 
initialise :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ 
initialise a1 =
  withHG3DClass a1 $ \a1' -> 
  initialise'_ a1' >>= \res ->
  return ()
{-# LINE 56 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}

-- | Sets the default anisotropy level to be used for loaded textures, for when textures are loaded automatically (e.g. by MaterialThe default value is 1 (no anisotropy). 
setDefaultAnisotropy :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Int  -- ^ maxAniso
  ->  IO ()
 -- ^ 
setDefaultAnisotropy a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromIntegral a2} in 
  setDefaultAnisotropy'_ a1' a2' >>= \res ->
  return ()
{-# LINE 61 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}

-- | get the default maxAnisotropy 
getDefaultAnisotropy :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Int)
 -- ^ 
getDefaultAnisotropy a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getDefaultAnisotropy'_ a1' a2' >>= \res ->
  peekIntConv  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 66 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}

-- | Returns a pointer to the default MaterialOgreMaterialThe default settings begin as a single Technique with a single, non-programmable Pass: 
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
--
getDefaultSettings :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (SharedPtr)
 -- ^ 
getDefaultSettings a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getDefaultSettings'_ a1' a2' >>= \res ->
  peekSharedPtr  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 71 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}

-- | Returns the name of the active material scheme. Technique::setSchemeName 
getActiveScheme :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (String)
 -- ^ 
getActiveScheme a1 =
  withHG3DClass a1 $ \a1' -> 
  alloc64k $ \a2' -> 
  getActiveScheme'_ a1' a2' >>= \res ->
  peekCString  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 76 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}

-- | Sets the name of the active material scheme. Technique::setSchemeName 
setActiveScheme :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ schemeName
  ->  IO ()
 -- ^ 
setActiveScheme a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  setActiveScheme'_ a1' a2' >>= \res ->
  return ()
{-# LINE 81 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}

-- | Override standard Singleton retrieval. Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. 
getSingletonPtr :: IO (HG3DClass)
 -- ^ 
getSingletonPtr =
  alloca $ \a1' -> 
  getSingletonPtr'_ a1' >>= \res ->
  peek  a1'>>= \a1'' -> 
  return (a1'')
{-# LINE 85 ".\\HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs.h ogre_mtrlmgr_construct"
  new'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs.h ogre_mtrlmgr_destruct"
  delete'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs.h ogre_mtrlmgr_initialise"
  initialise'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs.h ogre_mtrlmgr_setDefaultAnisotropy"
  setDefaultAnisotropy'_ :: ((HG3DClassPtr) -> (CUInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs.h ogre_mtrlmgr_getDefaultAnisotropy"
  getDefaultAnisotropy'_ :: ((HG3DClassPtr) -> ((Ptr CUInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs.h ogre_mtrlmgr_getDefaultSettings"
  getDefaultSettings'_ :: ((HG3DClassPtr) -> ((SharedPtrPtr) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs.h ogre_mtrlmgr_getActiveScheme"
  getActiveScheme'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs.h ogre_mtrlmgr_setActiveScheme"
  setActiveScheme'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMaterialManager.chs.h ogre_mtrlmgr_getSingletonPtr"
  getSingletonPtr'_ :: ((HG3DClassPtr) -> (IO ()))
