-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassVertexAnimationTrack.chs

-- 

module HGamer3D.Bindings.Ogre.ClassVertexAnimationTrack where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.Ogre.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}
import HGamer3D.Bindings.Ogre.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}
import HGamer3D.Bindings.Ogre.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}
import HGamer3D.Bindings.Ogre.EnumVertexAnimationType
{-# LINE 43 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}
import HGamer3D.Bindings.Ogre.EnumVertexAnimationTrackTargetMode
{-# LINE 44 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}

-- | Constructor. 
new :: HG3DClass  -- ^ parent
  ->  Int  -- ^ handle
  ->  EnumVertexAnimationType  -- ^ animType
  ->  IO (HG3DClass)
 -- ^ 
new a1 a2 a3 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromIntegral a2} in 
  let {a3' = cIntFromEnum a3} in 
  alloca $ \a4' -> 
  new'_ a1' a2' a3' a4' >>= \res ->
  peek  a4'>>= \a4'' -> 
  return (a4'')
{-# LINE 52 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}

-- | Get the type of vertex animation we're performing. 
getAnimationType :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (EnumVertexAnimationType)
 -- ^ 
getAnimationType a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getAnimationType'_ a1' a2' >>= \res ->
  peekEnumUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 57 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}

-- | Applies an animation track to the designated target. 
apply :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  HG3DClass  -- ^ timeIndex
  ->  Float  -- ^ weight
  ->  Float  -- ^ scale
  ->  IO ()
 -- ^ 
apply a1 a2 a3 a4 =
  withHG3DClass a1 $ \a1' -> 
  withHG3DClass a2 $ \a2' -> 
  let {a3' = realToFrac a3} in 
  let {a4' = realToFrac a4} in 
  apply'_ a1' a2' a3' a4' >>= \res ->
  return ()
{-# LINE 64 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}

-- | Set the target mode. 
setTargetMode :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  EnumVertexAnimationTrackTargetMode  -- ^ m
  ->  IO ()
 -- ^ 
setTargetMode a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = cIntFromEnum a2} in 
  setTargetMode'_ a1' a2' >>= \res ->
  return ()
{-# LINE 69 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}

-- | Get the target mode. 
getTargetMode :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (EnumVertexAnimationTrackTargetMode)
 -- ^ 
getTargetMode a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getTargetMode'_ a1' a2' >>= \res ->
  peekEnumUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 74 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}

-- | Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out. 
hasNonZeroKeyFrames :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ 
hasNonZeroKeyFrames a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  hasNonZeroKeyFrames'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 79 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}

-- | Optimise the current track by removing any duplicate keyframes. 
optimise :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ 
optimise a1 =
  withHG3DClass a1 $ \a1' -> 
  optimise'_ a1' >>= \res ->
  return ()
{-# LINE 83 ".\\HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs.h ogre_vat_construct"
  new'_ :: ((HG3DClassPtr) -> (CUShort -> (CInt -> ((HG3DClassPtr) -> (IO ())))))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs.h ogre_vat_getAnimationType"
  getAnimationType'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs.h ogre_vat_apply"
  apply'_ :: ((HG3DClassPtr) -> ((HG3DClassPtr) -> (CFloat -> (CFloat -> (IO ())))))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs.h ogre_vat_setTargetMode"
  setTargetMode'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs.h ogre_vat_getTargetMode"
  getTargetMode'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs.h ogre_vat_hasNonZeroKeyFrames"
  hasNonZeroKeyFrames'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassVertexAnimationTrack.chs.h ogre_vat_optimise"
  optimise'_ :: ((HG3DClassPtr) -> (IO ()))
